/*
 *  dialoguestructs.hpp
 *  Template
 *
 *  Created by increpare on 29/03/2009.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#include <vector>
#include <map>
#include <string>

#include <boost/assign/list_of.hpp>
using namespace boost::assign;
using namespace boost;

using namespace std;

enum Actors {
	PLAYER=0,
	LADY=1,
	BARTENDER=2,
	CLUBBER=3,
	DETECTIVE=4,
	MURDERER=5,
	VICTIM=6,
	DETECTIVE_AFTER=7,
	DETECTIVE_AFTER2=8,
	INVALID_ACTOR=9,
	GMURDERER=9,
	GPLAYER=10
};

class Dialogue_Line {
public:
	Actors speaker;
	string line;
};

struct PersonConv {
	vector<Dialogue_Line> conversation;
	vector<string> afterthoughts1;
	vector<string> afterthoughts2;
};

#define D(x,y) ((Dialogue_Line){x,(string)y})
#define L(x) (list_of x )

unsigned int actorcount=5;

typedef string s;

bool talkedto[12];
int clearthoughts;
int sexthoughts;
bool thoughtabout[12];

//dialogue[actor].push_back({actor},{string});



unsigned int scene=0;
Actors actorconv=PLAYER;
unsigned int linenumber=0;
map<Actors,PersonConv > script;

void setdialogue()
{
	script.clear();

	#define start_dialogue_dat { Actors conv_with=PLAYER;
	#define conversation_with(x) \
	conv_with=x;\
	script[conv_with].conversation.clear();\
	script[conv_with].afterthoughts1.clear();\
	script[conv_with].afterthoughts2.clear();

	#define line(speaker,text) script[conv_with].conversation.push_back((Dialogue_Line){speaker,(string)text + " "});
	#define think1(text) script[conv_with].afterthoughts1.push_back((string)text+" ");
	#define think2(text) script[conv_with].afterthoughts2.push_back((string)text+" ");
	#define stop_dialogue_dat }
	#define player(x) line(PLAYER,x)
	#define lady(x) line(LADY,x)
	#define bartender(x) line(BARTENDER,x)
	#define clubber(x) line(CLUBBER,x)
	#define detective(x) line(DETECTIVE,x)
	#define murderer(x) line(MURDERER,x)
	#define gmurderer(x) line(GMURDERER,x)
	#define gplayer(x) line(GPLAYER,x)

	switch (scene)
	{

		case 0:
			start_dialogue_dat

			conversation_with(PLAYER)
			//NOTHING HERE

			conversation_with(LADY)
			player("What are you doing, hanging around here?")
			lady("Name's Maggie")
			player("Excuse me.  I'm detective O'Reilly, and I've been assigned to the case.")
			lady("The murder, you mean.")
			player("Yes, the murder.")
			lady("I've been waiting outside here all morning, waiting for word of Peter.")
			player("I'm afraid I can't tell you anything yet myself, ma'am, but I would appreciate it if you could answer me some questions.")
			lady("Of course.")
			player("When was the last time you saw Peter?")
			lady("I had lunch with him yesterday, at a bar in town; he was so excited.")
			player("Why?")
			lady("Oh he was boasting about he was going to meet up with a really hot guy tonight.")
			player("He tell you anything about him?")
			lady("No. I don't honestly think he knew much himself.")
			player("Were you around here last night?")
			lady("No, I had to work this morning.")
			player("Anything else you think I should know?")
			lady("I don't think so, O'Reilly.")
			player("Okay ma'am.  I'll let you know as soon as I have any news, but you'd be better getting yourself in out of the cold.")
			lady("Thanks, O'Reilly, but I don't feel like being cooped up inside right now.")
			lady("Oh, you might want to ask around in the bar there; I think it's open by now.")
			player("Thanks Maggie.")

			think1("She seems like a nice enough girl, too warm to kill any man.")
			think1("It's a pity she didn't know more; she's one of those few people you know you can trust straight off.")

			think2("I should probably have asked her about Tony.")
			think2("I wonder if he has a boyfriend.")
			think2("Oh, O'Reilly, stop being such a stupid boy; he's a witness, and a suspect, like everyone else.")
			think2("He has such a nice mouth, though.")
			think2("He must give great blowjobs.")
			think2("Fucking christ! Get your mind on the job, O'Reilly.")

			conversation_with(BARTENDER)
			player("Excuse me, sir, do you have a minute?")
			bartender("You're here about the murder?")
			player("Yes.  I'm detective O'Reilly. Could you answer some questions for me?")
			bartender("Sure, but don't for a second pretend you're going to do anything about it.")
			bartender("You fucking pigs haven't done a thing for us here, not in my memory.")
			player("What's your name?")
			bartender("John, John Milles.")
			player("Were you working here last night?")
			bartender("Yeah, sure.")
			player("Did you see Peter at all?")
			bartender("It was pretty busy, but I think I laid eyes on him once or twice.")
			player("You see him with anyone?")
			bartender("No; I think he must've been at the far side of the bar; probably shaking his ass on the dance-floor.")
			player("Was he a regular here?")
			bartender("Peter was, sure.  I had got to know him pretty well.  Nice guy.")
			player("Thanks for your cooperation.  I'll do what I can to find the murderer.")
			bartender("I don't mean to doubt you; you seem pretty sweet for a cop, but I'll believe it when I see it.")
			player("Here's hoping.")

			think1("Well that was some help anyway.  Peter was at least here last night.")
			think1("Now I'll just have to hope later on I'll bump into someone who saw something more.")
			think1("It's a shame the cops don't have a better reputation around here.")

			think2("I wonder if Tony comes here often.")
			think2("Does he get much action?")
			think2("Maybe he'll be here later tonight.")
			think2("Maybe he'll try feel me up.")
			think2("Maybe we'll fuck.")

			conversation_with(CLUBBER)
			//NO CLUBBER IN THIS SCENE

			conversation_with(DETECTIVE)
			player("Morning Sergeant,")
			detective("O'Reilly.  What took you so long?")
			player("I got caught up at the station.")
			detective("How about you arrive on time next time, yeah?")
			player("Sure.")
			player("So, could you tell me what we have on our hands here?")
			detective("Yeah, some fag was out in the park last night, got his brains blasted out.")
			player("Any leads?")
			detective("Nah, it was probably just some piece-of-shit queer.")
			player("Have you questioned anyone yet?")
			detective("That's your job, detective.")
			player("I'm aware of that, Sergeant.  Anything else I should know?")
			detective("Not that I can think of, O'Reilly.")
			detective("And look: we've got better things to be investigating than this, so don't waste your time on it.")
			player("I'll make that call myself, Sergeant.")
			detective("Do whatever you want, O'Reilly, just come back and talk to me when you've questioned everyone so I can wrap up here and get back to the station.")

			think1("That sergeant's such a fucking hateful bastard.  The sooner I'm promoted away from him, the better.")
			think1("I'll probably still be working with assholes, but at least the pay will be better.")

			//no think2

			conversation_with(MURDERER)
			player("Detective O'Reilly, I'm investigating the murder; do you have a minute?")
			murderer("Sure I do, handsome.")
			player("What's your name?")
			murderer("My name's Tony Luchiati.  Most people call me Luchiati, but you can call me Tony.")
			player("Did you know Peter?")
			murderer("A little, sure.  He had a nice cock, and a real good tight ass.")
			player("You were seeing him?")
			murderer("No, just a couple of fucks.  You look like you've a nice ass.")
			player("Were you here last night?")
			murderer("I was in early.  Saving my energy for tonight.  You coming out tonight, O'Reilly?")
			murderer("You should; I'm sure we'd have a good time.  You look like you haven't had a good fuck in years.")
			player("You know anything else you think would help our investigations?")
			murderer("No, but how about you give me your number, in case I think of something?")
			player("You think of thinking, you call the station.")
			murderer("Okay, O'Reilly.")
			murderer("I'm serious about wanting to fuck you, though.  It'll be good for both of us.")


			//no think 1

			think2("Man that guy was full-on.")
			think2("He was pretty fucking hot stuff, though.")
			think2("Tony, yeah...will have to remember that name.")
			think2("He was right, though; I haven't had a good fuck in too long.")
			think2("He looks like a pretty good fuck.")
			think2("Better wait 'til the case is closed, though.")


			conversation_with(VICTIM)
			player("Poor man; you surely must have known the risks you were taking, out here last night.")

			think1("What sort of pleasure must it take for someone to risk their lives in this way?")

			think2("Uch; revolting.  It could have been Tony dead here, his face in pieces.")
			think2("I don't think I've ever seen a face as beautiful as Tony's.")

			conversation_with(DETECTIVE_AFTER)
			detective("O'Reilly, you get your questions asked?")
			player("Yeah, sure; I'll go back and file them now.")
			detective("Thank fuck; then we can call it a day.")
			player("I think I might call back later, ask around a little more when there're more people about.")
			detective("Do whatever the fuck you want, O'Reilly; so long as I can get home on time and be with my kids instead of around these fucking freak shows I don't give a damn.")

			conversation_with(DETECTIVE_AFTER2)
			detective("O'Reilly, you get your questions asked?")
			player("Yeah, sure; I'll go back and file them now.")
			detective("Thank fuck; then we can call it a day.")
			player("Yeah, let's head back to the station.")

			//NO THOUGHTS
			stop_dialogue_dat
			break;
		case 1:
		{
			start_dialogue_dat

			conversation_with(PLAYER)
			//NO CONV

			//START ON THINK1
			think1("Right.  I guess I should ask around, then.")

			conversation_with(LADY)

			lady("I didn't think I'd see you hanging around a place like this.")
			player("Seems like the best time to get some answers.")
			lady("Speaking of questions; Luchiati's been asking around about you, I think he has his eyes on you.")
			player("Certainly felt like that earlier.")
			lady("Be careful around him, O'Reilly; he's got it going on, but he's not exactly a wholesome character.")
			player("I'm not here to pick up, Maggie, I'm here to work.")
			lady("I'm sorry, I didn't mean to...")
			player("Don't worry. I'll let you get back to the party anyway.")

			think1("Sounds like Tony's been acting pretty suspiciously.  Best be on my guard.")
			think1("Could it really have been him, though? A murderer?")

			think2("Oh man, he's been asking about me.")
			think2("Oh god oh christ oh fuck.")
			think2("This is such a chance, such an opportunity.")
			think2("To be with a guy like Tony, even just for a night.")
			think2("A man could die happy after a night with a man like that.")
			think2("I'm not getting paid for this anyway, and the people at the station don't give a damn.")

			conversation_with(BARTENDER)
			bartender("Hey, O'Reilly, find out anything yet?")
			player("I came here to ask some questions 'round.")
			player("Anything happen here since earlier?")
			bartender("It's only gotten busy here about a half hour ago.")
			player("How long as Tony been here for?")
			bartender("Oh he's been loitering about since earlier-on.")
			player("Does he even have a job?")
			bartender("He does shift-work somewhere, I think.")
			bartender("I can see him, over there; he's giving you the eye, O'Reilly.")

			think1("Why, why is he looking at me?")

			think2("I wish, I wish I could get my head straight.")
			think2("To get Tony, that man, that very wonder, out of my mind, just for a moment.")

			conversation_with(CLUBBER)
			player("Hey, do you have a minute?")
			clubber("Sure handsome.  Nice cologne you're wearing.")
			player("Detective O'Reilly, I'm investigating the murder that happened last night out in the park.")
			clubber("Oh, that guy, yeah; I heard about that.")
			player("Did you know the victim?")
			clubber("Not really.  He had a nice cock though, and a tight ass.")
			player("So I hear.  Were you about here last night?")
			clubber("Yeah, but I was off my head on E before I'd even got here.")
			clubber("Oh shit!  Are you going to book me for that?")
			player("I'm just here about the murder.  You don't remember anything?")
			clubber("Ah let me think...")
			clubber("Come to think of it, I do think I saw him yesterday, that guy...")
			player("Peter.")
			clubber("Yeah, that guy; he was getting felt up by Luchiati on the dance-floor, lucky guy")
			player("Is he really that good?")
			clubber("He's everything that a man could dream of.")
			clubber("A bit kinky maybe, but he can really pull it off!")
			player("I bet.")

			think1("That sounds pretty suspicious.  I'm going to keep an eye on Tony.")

			think2("Men would give anything to be held by Tony.")
			think2("He really gets around, but...I think that; he seems different towards me.")
			think2("Fuck!  I'm feeling jealous affection towards a man who hasn't even fucked me.")
			think2("Best do something about that, then, hah.")


			//NODETECTIVE

			conversation_with(MURDERER)

			player("Tony, hey.")
			murderer("Oh boy am I glad to see you here, O'Reilly.")
			player("You've not heard any more information about last night yet, have you?")
			murderer("You smell good tonight, O'Reilly.")
			player("Don't play with me, Tony.")
			murderer("Okay then.  I live two blocks north; flat 45.  Call over later on, if you want.  I'll be waiting.")
			murderer("And no, I ain't heard anything more about Peter or last night.")

			think1("He got pretty defensive there; dropped his usual charms.")

			think2("Waiting for me...")
			think2("I'm so close to being on the receiving end of a lovingly engorged cock.")
			think2("He is...he is so much of everything; there is nobody else like him.")
			think2("So what do I think I'm going to do?")

			conversation_with(VICTIM)
			//NONE
			conversation_with(DETECTIVE_AFTER)
			//NONE

			stop_dialogue_dat

			break;
	}
		case 2:
		{
			start_dialogue_dat
			//INEXCUSABLE
			conversation_with(PLAYER)
			murderer("I'm so happy that you've come to me, O'Reilly.")
			player("Little could keep me away, Tony.")
			gmurderer("Look at me, O'Reilly.")
			gplayer("Wait, what's that...a gun?")
			gmurderer("Look at me.")
			gplayer("Tony, quit fucking about.  Put the gun down")
			gmurderer("O'Reilly, I really like the look of you.  I don't think I'll ever have killed someone I liked so much before.")
			gplayer("Calm down...")
			gmurderer("Don't pretend that you're not getting some pleasure from this as well.")
			gplayer("No, Tony, I'm not. Put the gun down, and we can talk.")
			gmurderer("Don't lie to me, O'Reilly!")
			gplayer("Tony, I was hoping for a good fuck, not to have a gun pulled on me.")
			gmurderer("You're all the same, you fucking cops.")
			gplayer("Tony, please...")
			gmurderer("Fuck you, O'Reilly.")


			conversation_with(MURDERER)
			murderer("O'Reilly, I knew you'd come.")
			player("I haven't been able to get you out of my mind all day.")
			murderer("Am I everything you think about?")
			player("What else is there?")
			murderer("Nothing, O'Reilly, nothing but me.")
			player("Fuck me, Tony.")
			murderer("What would you be willing to do for a fuck, O'Reilly?")
			player("Anything, Tony.")
			murderer("Anything?")
			player("Everything.")
			murderer("Would you beat someone up for me, if they were giving me trouble?")
			player("If they were here, they'd be fit for a hospital.")
			murderer("Would you take the beating for me?")
			player("I can't think of a nobler act.")
			murderer("What if it was for my pleasure?")
			player("Then...it would be for my pleasure also.")
			murderer("Would you kill someone, to have my cock inside you?")
			player("If they were here with us right now, they'd already be dead.")
			murderer("What if I were to take out a gun right now?")
			player("I would feel as safe as I ever have.")
			murderer("What if I were to point it right at you.")
			player("Then I would relish the attention you were paying me.")
			murderer("What if I were to tell you that I was to shoot you.")
			player("Then I would consider myself blessed to be the target of such affection.")
			murderer("Do you love me, O'Reilly?")
			player("Yes.")
			murderer("Do you think that I love you?")
			player("I wouldn't want to suppose.")
			murderer("I think...that I might love you, O'Reilly.")
			player("Do you have a gun?")
			murderer("Yes.")
			player("Take it out.")
			gmurderer("I am going to shoot you, O'Reilly.")
			gplayer("And I...I have never been so...")

			stop_dialogue_dat
			break;
		}
	}
}

char* endingtexts[5] =
{
//0: gives up at end of first scene
"I never thought much about the case after that.",
//1: gives up, having found nothing at end of second scene
"It was a waste of time, going back to that bar; nobody could tell me anything.  Time to give up the case as hopeless.",
//2:resolves
"Tony.  I'm deeply suspicious of him. I think Tony might have done it. I can't arrest him off-duty, but I'll call to his place first thing in the morning with a search warrant.",
//3: get shot
"",
//4: get shot
""
};

int endingtype;

typedef vector<Dialogue_Line>  Dialogue;

Dialogue curdialogue;
